#include <math.h>
#include <windows.h>
#include <mmsystem.h>

#define abs2(x) ((x)>=0?(x):(-(x)))

int searchpad(void) {
	int i,j;
	JOYCAPS jc;
	j=joyGetNumDevs();
	for(i=0;i<j;i++) {
		if(!joyGetDevCaps(i,&jc,sizeof(jc)))return i;
	}
	return -1;
}

int inputanalog(double* x,double* y,int id) {
	JOYINFOEX ji;
	JOYCAPS jc;
	ji.dwSize=sizeof(ji);
	ji.dwFlags=JOY_RETURNALL;
	if(joyGetDevCaps(id,&jc,sizeof(jc)))return 0;
	joyGetPosEx(id,&ji);
	*x=((double)ji.dwXpos-(double)(jc.wXmax-jc.wXmin)/2.0)/
		((double)(jc.wXmax-jc.wXmin)/2.0);
	*y=((double)ji.dwYpos-(double)(jc.wYmax-jc.wYmin)/2.0)/
		((double)(jc.wYmax-jc.wYmin)/2.0);
	return 1;
}

void analoghosei(double* hx,double* hy,double x,double y) {
	double length;
	double max;
	if(x==0 && y==0) {
		*hx=0;
		*hy=0;
		return;
	}
	if(abs2(x)>=abs2(y))max=y/x; else max=x/y;
	length=sqrt(1+max*max);
	*hx=x/length;
	*hy=y/length;
}
